DROP TABLE IF EXISTS Person;
CREATE TABLE Person (
  id       BIGINT                              AUTO_INCREMENT PRIMARY KEY,
  name      VARCHAR(128),
  firstname VARCHAR(128),
  gender   ENUM('', 'male', 'female') NOT NULL DEFAULT 'male',
  groups   SET('', 'a', 'b', 'c')     NOT NULL DEFAULT '',
  birthday DATE                       NOT NULL DEFAULT '0000-00-00'
);

#
# Create Demo
INSERT INTO Person (id, name, firstname, gender, groups) VALUES
  (NULL, 'Doe', 'John', 'male', 'c'),
  (NULL, 'Smith', 'Jane', 'female', 'a,c');


DROP TABLE IF EXISTS PersFunction;
CREATE TABLE PersFunction (
  id       BIGINT        AUTO_INCREMENT PRIMARY KEY,
  personId BIGINT,
  type     ENUM('Student', 'Assistant', 'Professor', 'Administration'),
  start    DATE NOT NULL DEFAULT '0000-00-00',
  end      DATE NOT NULL DEFAULT '0000-00-00',
  note     VARCHAR(255)
);

# ---------------------------
# Form: plain
REPLACE INTO Form (id, name, title, noteInternal, tableName, permitNew, permitEdit, render, multiSql, parameter) VALUES
  (3, 'formplain', 'Form: Plain', '', 'Form', 'always', 'always', 'plain', '', '');

# FormEditor: FormElements
REPLACE INTO FormElement (id, formId, name, label, mode, type, checkType, class, ord, size, maxLength, note, clientJs, value, sql1, sql2, parameter, feIdContainer, subrecordOption, modeSql)
VALUES
  (300, 3, 'id', 'id', 'readonly', 'text', 'all', 'native', 100, 0, 11, '', '', '', '', '', '', 0, '', ''),
  (310, 3, 'name', 'Name', 'show', 'text', 'all', 'native', 120, 0, 255, '', '', '', '', '', '', 0, '', '');

# Form: table
REPLACE INTO Form (id, name, title, noteInternal, tableName, permitNew, permitEdit, render, multiSql, parameter) VALUES
  (4, 'formtable', 'Form: Table', '', 'Form', 'always', 'always', 'table', '', '');

# FormEditor: FormElements
REPLACE INTO FormElement (id, formId, name, label, mode, type, checkType, class, ord, size, maxLength, note, clientJs, value, sql1, sql2, parameter, feIdContainer, subrecordOption, modeSql)
VALUES
  (400, 4, 'id', 'id', 'readonly', 'text', 'all', 'native', 100, 0, 11, '', '', '', '', '', '', 0, '', ''),
  (410, 4, 'name', 'Name', 'show', 'text', 'all', 'native', 120, 0, 255, '', '', '', '', '', '', 0, '', '');


# Form: Person
REPLACE INTO Form (id, name, title, noteInternal, tableName, permitNew, permitEdit, render, multiSql, parameter) VALUES
  (5, 'person', 'Person {{SELECT ": ", firstName, " ", name, " (", id, ")" FROM Person WHERE id = {{r:S0}}}}',
   'Please secure the form',
   'Person', 'always', 'always', 'bootstrap', '', '');

# FormEditor: FormElements
REPLACE INTO FormElement (id, formId, name, label, mode, type, checkType, class, ord, size, maxLength, note, clientJs, value, sql1, sql2, parameter, feIdContainer, subrecordOption, modeSql)
VALUES

  (500, 5, 'name', 'Name', 'show', 'text', 'all', 'native', 10, 0, 255, '', '', '', '', '', '', 0, '', ''),
  (501, 5, 'firstname', 'Firstname', 'show', 'text', 'all', 'native', 20, 0, 255, '', '', '', '', '', '', 0, '', ''),
  (502, 5, 'birthday', 'Birthday', 'show', 'date', 'all', 'native', 30, 0, 255, '', '', '', '', '', '', 0, '', ''),
  (506, 5, 'gender', 'Sex', 'show', 'radio', 'alnumx', 'native', 40, 0, 0, '', '', '', '', '', 'itemList=female,male',
   0, '', ''),
  (503, 5, 'datumZeit', 'Datum & Zeit', 'show', 'datetime', 'alnumx', 'native', 50, 0, 0, '', '', '', '', '', '', 0,
   '', ''),
  (504, 5, 'zeit', 'Zeit', 'show', 'time', 'alnumx', 'native', 60, 0, 0, '', '', '', '', '', '', 0, '', ''),
  (505, 5, 'picture', 'Picture', 'show', 'upload', 'allbut', 'native', 70, 0, 0, '', '', '', '', '',
   'pathFileName={{SELECT ''fileadmin/user/pictures/'', p.name, ''-{{_filename}}'' FROM Person AS p WHERE p.id={{r}} }}',
   0, '', '');

# ----------------------------------------------------------------------
#
DROP TABLE IF EXISTS Address;
CREATE TABLE Address (
  id        BIGINT AUTO_INCREMENT PRIMARY KEY,
  personId BIGINT,
  street    VARCHAR(128),
  city      VARCHAR(128),
  country   ENUM('Switzerland', 'Austria', 'France', 'Germany'),
  gr_id_typ BIGINT
);

INSERT INTO Address (personId, street, city) VALUES
  (1, 'Side Street', 'Zurich'),
  (1, 'Park Street', 'Zurich'),
  (1, 'Winter Street', 'Zurich'),
  (2, 'Summer Street', 'Zurich');


